/*
 *  TOPPERS/JSP Rose-RT Link Programs
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2004 by Platform Development Center
 *                              RIOCH COMPANY,LTD. JAPAN
 * 
 *  L쌠҂́CFree Software Foundation ɂČ\Ă 
 *  GNU General Public License  Version 2 ɋLqĂC
 *  (1)`(4)̏𖞂ꍇɌC{\tgEFAi{\tgEF
 *  Aς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFAėp\ȃoCiR[hiP[^uIu
 *      WFNgt@C⃉CuȂǁǰ`ŗpꍇɂ́Cp
 *      ɔhLgip҃}jAȂǁjɁCL̒쌠\C
 *      ̗pщL̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAėps\ȃoCiR[ȟ`܂͋@ɑg
 *      ݍ񂾌`ŗpꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) pɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) p̌`ԂCʂɒ߂@ɂāCL쌠҂ɕ񍐂
 *        ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂́C
 *  {\tgEFAɊւāC̓Kp\܂߂āCȂۏ؂s
 *  ȂD܂C{\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ
 *  Ȃ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: sample.c,v 1.1 2004/02/10 12:03:24 roi Exp $
 */

/* 
 *  BridgePointJSP-1.4̃NEvO̖{̂̓e
 *  fOstub֐ɋLqD
 *  Ovenfł͕KKvł͂ȂD
 *
 */

#include <t_services.h>
#include "kernel_id.h"
#include "sample.h"

/*
 *  [Zɑ΂CPUOnh
 */

void
exc_handler(EXCEPTION_POINTERS * p_excinf, int * exc)
{
    ID	tskid;

    syslog_0(LOG_NOTICE, "CPU Exception Raised");
    syslog_4(LOG_NOTICE,
    "vxsns_loc = %d vxsns_ctx = %d vxsns_dsp = %d vxsns_dpn = %d",
    vxsns_loc(p_excinf), vxsns_ctx(p_excinf),
    vxsns_dsp(p_excinf), vxsns_dpn(p_excinf));

    if (!vxsns_loc(p_excinf) && !vxsns_ctx(p_excinf)) {
        syscall(iget_tid(&tskid));
        syscall(iras_tex(tskid, 0x8000));
    }

	p_excinf->ContextRecord->Eip += 2;
	*exc = EXCEPTION_CONTINUE_EXECUTION; 
}

