/*****************************************************************************
 * File:       PIO_bridge.h
 *
 * Description:
 *
 * External Entity: 'Process IO'  (PIO)
 ****************************************************************************/

#ifndef PIO_BRIDGE_H
#define PIO_BRIDGE_H

#ifdef	__cplusplus
extern "C" {
#endif

#include "sys_mechs.h"
#include "sys_types.h"

/*****************************************************************************
 * Bridge:  Cg_
 ****************************************************************************/
extern void PIO_JP_1( void );

/*****************************************************************************
 * Bridge:  Cg
 ****************************************************************************/
extern void PIO_JP_2( void );

/*****************************************************************************
 * Bridge:  p[`[uւ̓d͂
 ****************************************************************************/
extern void PIO_JP_3( void );

/*****************************************************************************
 * Bridge:  p[`[uւ̓d͂~
 ****************************************************************************/
extern void PIO_JP_4( void );

/*****************************************************************************
 * Bridge:  hA₢킹
 ****************************************************************************/
extern bool PIO_JP_5( void );

/*****************************************************************************
 * Bridge:  enable_interrupt
 ****************************************************************************/
extern void PIO_enable_interrupt( void );

/*****************************************************************************
 * Bridge:  disable_interrupt
 ****************************************************************************/
extern void PIO_disable_interrupt( void );

/*****************************************************************************
 * Bridge:  uU[I
 ****************************************************************************/
extern void PIO_JP_6( void );

/*****************************************************************************
 * Bridge:  uU[It
 ****************************************************************************/
extern void PIO_JP_7( void );


#ifdef	__cplusplus
}
#endif

#endif  /* PIO_BRIDGE_H */

